#============================================#
#-------------- DonnesTree  ----------------#
#============================================#
library(car)
library(lme4)
library(ape)
library(psych)
library(rms)
library(irr)
library(fmsb)
setwd("C:\\Users\\Julien\\Desktop\\PLoS_One_Supplementary_Materials")

data<-read.tree("wtree15_R_Compatible.nwk")
societe<-read.csv("data_PIC.csv",header=TRUE,sep="\t")
societe_data<-read.csv("bilan_ethno homosexualit.csv",header=TRUE,sep="\t")
load("EAfact.Rdata")


#=== Enlever de l'arbre de l'ASJP les socits pour lesquelles on n'a pas de donnes ===#
societe_sans_donnees<-NULL
for(i in 1:length(data$tip))
	{
	 if(length(which((data$tip[i]==societe[,1])=="TRUE"))==0) #Teste si chaque socit est prsente dans le jeu de donnes 
		{ 
	   societe_sans_donnees<-c(societe_sans_donnees,i)
		}
	}

data <- drop.tip(data, data$tip[societe_sans_donnees])

#=== Associer les donnes du "Bilan ethno homosexualit" avec celles de l'arbre ASJP en utilisant le fichier "data_PIC" ===#
dataSociete<-merge(societe_data,societe,by.x="Culture",by.y="Societe_donnees")

#====================================================================================================#
#================ Rcuprer les infos sur la stratification  partir de l'Ethnographic Atlas ========#
#====================================================================================================#

societe_strat_EA<-c(
493 ,#CHIPEWYAN
42 ,#SANTAL
38 ,#YAKUT
446 ,#YUMA.
280,#MARICOPA
532 ,#N.POMO.
533, #E.POMO.
534, #S.POMO.
97 ,#BORORO
505 ,#TLINGIT
171 ,#KWAKIUTL
47 ,#GARO
140 ,#LEPCHA
239 ,#TIBETANS
147 ,#LAKHER
98 ,#TRUMAI
183 ,#ZUNI
400 ,#TUPINAMBA
91 ,#SIRIONO
523 ,#KLAMATH
174 ,#YOKUTS
385 ,#NATCHEZ
1238 ,#TUKANO (TUCANO)
404 ,#ZULU
992 ,#MOSSI (MOORE)
117 ,#AZANDE (ZANDE)
10 ,#FON (FONGBE, DAHOMEANS)
643 ,#IBO (IGBO)
655 ,#KWOMA
143 ,# TODA
688 ,#TELUGU
44 ,#TAMIL
89 ,#YARURO
217 ,#MAMVU
120 ,#NUER
219 ,#LANGO
326 ,#OKINAWANS
21  ,#WOLOF
435 ,#TEWA
502 ,#E.OJIBWA
77 ,#OJIBWA
499 ,#CHIPPEWA
268 ,#NASKAPI
279 ,#DELAWARE
661 ,#MENOMINI
56  ,#ARANDA
508 ,#QUINAULT
176 ,#SANPOIL
195 ,#MAPUCHE
191 ,#JIVARO
113 ,#DOGON
622 ,#HIDATSA
178 ,#CROW
341 ,#MANDAN
1104 ,#PONCA
696 ,#OTO
347 ,#WITOTO
379 ,#YUKI  
92  ,#TUCUNA
85  ,#CUNA
391 ,#GOAJIRO
135 ,#CHUKCHEE
235 ,#KORYAK
458 ,#ALEUT
1135,#IRANIANS
913 ,#KURD
852 ,#MALE 
29  ,#ICELANDER
193 ,#AYMARA
93  ,#INCA
182 ,#NAVAHO
81 ,#CHIRICAHU
342 ,#PAWNEE
225 ,#BASQUES
345 ,#YUCATECMA 
1264 ,#YANOMAMO
37  ,#GILYAK
180 ,#CREEK
367,#SIAMESE
679 ,#AMHARA ,#AMHARIC
172 ,#YUROK
74   ,#S.UTE
442 ,#HOPI
173 ,#TUBATULAB
1160 ,#PIMA
83 ,#TARAHUMAR
198  ,#NAMBICUAR
165 ,#LAU
65 ,#SAMOANS
376 ,#HAWAIIANS
1126 ,#EASTER
66   ,#TIKOPIA
1124 ,#TONGANS
166  ,#PUKAPUKAN
62   ,#TROBRIAND
373  ,#MANUS
59   ,#PALAUANS
53   ,#IBAN
54   ,#Javanese
251  ,#Dunsun malang
427  ,#CHAMORRO
64, #SENIANG
154  ,#ALORESE chez moi ALOR
150  ,#IFUGAO
428  ,#ULITHIANS
60   ,#TRUKESE
1266 )#MARSHALLE




#====================================================================================================#
#====================================================================================================#
#====================================================================================================#
#=== Rcuprer les donnes de Stratification associes  l'Ethnographic Atlas (EA) ===#
Strat_EA<-read.table("Strat_EA.txt",header=T,sep="\t")
dataSociete<-merge(dataSociete,Strat_EA,by.x="Societe_ASJP",by.y="Societe_ASJP",all.x=T)

#================================================================================================================================#
#=============================== STATISTIQUES DESCRIPTIVES  =====================================================================#
#================================================================================================================================#

#===================================##===================================##===================================##===================================##===================================#
#===================================#
#=== Kappa concordance raters ======#
#===================================#
CultureKappa<-dataSociete$Culture
CultureKappa<-as.character(CultureKappa)

Michel<-dataSociete$MHP_Michel.HP.
Michel<-as.character(Michel)
Michel[which(Michel=="A")]<-"1"
Michel[which(Michel=="A?")]<-"2"
Michel[which(Michel=="P?")]<-"3"
Michel[which(Michel=="P")]<-"4"
Michel<-as.numeric(Michel)

Julien<-dataSociete$Prfrence_homosexuelle
Julien<-as.character(Julien)
Julien[which(Julien=="non")]<-"1"
Julien[which(Julien=="non?")]<-"2"
Julien[which(Julien=="oui?")]<-"3"
Julien[which(Julien=="oui")]<-"4"
Julien[which(Julien=="?")]<-NA
Julien<-as.numeric(Julien)

#Suppression donnes manquantes#
nodata<-which(is.na(Michel)==T) 
Michel<-Michel[-nodata]
Julien<-Julien[-nodata]
CultureKappa<-CultureKappa[-nodata]
verif<-cbind(Michel,Julien,CultureKappa)

verif[which(verif[,1]!=verif[,2]),]

cohen.kappa(cbind(Michel,Julien))
kappa2(cbind(Michel,Julien),weight="unweighted")
kappa2(cbind(Michel,Julien),weight="squared") # Permet d'avoir les p-value

#=== En rassemblant les donnes ===#
Michel2<-Michel
Michel2[which(Michel2==2)]<-1
Michel2[which(Michel2==3)]<-2
Michel2[which(Michel2==4)]<-2

Julien2<-Julien
Julien2[which(Julien2==2)]<-1
Julien2[which(Julien2==3)]<-2
Julien2[which(Julien2==4)]<-2

cohen.kappa(cbind(Michel2,Julien2))
kappa2(cbind(Michel2,Julien2))
#===================================#
#=== Mise en place des variables ===#
#===================================#

#=== Variable Homosexualit ===#
dataSociete$Prfrence_homosexuelle<-as.character(dataSociete$Prfrence_homosexuelle)
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="oui")]  <-1
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="oui?")] <-2
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="non?")] <-3
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="non")]  <-4
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="?")]    <-NA

#=== Rarrangement de la variable homo ===#
#--- Prparation de la variable rponse (homo) ---#
dataSociete$Prfrence_homosexuelle<-as.numeric(dataSociete$Prfrence_homosexuelle)
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="2")]<-1
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="3")]<-0
dataSociete$Prfrence_homosexuelle[which(dataSociete$Prfrence_homosexuelle=="4")]<-0

#===================================#
#=== Test des corrlations =========#
#===================================#
#=== Variable Stratification ===#
dataSociete$Nbe_de_Classes_sociales<-as.character(dataSociete$Nbe_de_Classes_sociales)
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="1")]       <-1
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="1 ou 2")] <-1.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="2")]       <-2
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="2 ou 3")]  <-2.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="3")]       <-3
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="3 ou 4")]  <-3.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="4")]       <-4
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="4 ou 5")]  <-4.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="5")]       <-5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="")]        <-NA
dataSociete$Nbe_de_Classes_sociales<-as.numeric(dataSociete$Nbe_de_Classes_sociales)
DataAnalyse<-cbind(as.character(dataSociete$Societe_ASJP),dataSociete$Prfrence_homosexuelle,dataSociete$Nbe_de_Classes_sociales)
colnames(DataAnalyse)<-c("Society","MHP","Stratification")
DataAnalyse<-as.data.frame(DataAnalyse)
Societe_Donnees_Manquantes<-unique(c(which(is.na(DataAnalyse$MHP)==T),which(is.na(DataAnalyse$Stratification)==T)))
DataAnalyse<-DataAnalyse[-Societe_Donnees_Manquantes,] #Supprimer les socits avec donnes manquantes du jeu de donnes
DataAnalyse$Stratification<-as.numeric(as.character(DataAnalyse$Stratification))# Prendre en compte les valeurs
#Rassemblement des classes#
DataAnalyse$Stratification[which(DataAnalyse$Stratification<2)]<-0
DataAnalyse$Stratification[which(DataAnalyse$Stratification<4 & DataAnalyse$Stratification>=2)]<-1
DataAnalyse$Stratification[which(DataAnalyse$Stratification>=4)]<-2


#=== Variable Stratification EA Class_strat===#
dataSociete$Class_Strat<-as.character(dataSociete$Class_Strat)
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="NA")]                       <-NA
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="absence among freemen")]    <-0
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="wealth distinctions")]      <-1
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="elite")]                    <-2
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="dual")]                     <-3
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="complex")]                  <-4
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="missing data")]             <-NA
dataSociete$Class_Strat<-as.numeric(dataSociete$Class_Strat)
DataAnalyseEA<-cbind(as.character(dataSociete$Societe_ASJP),dataSociete$Prfrence_homosexuelle,dataSociete$Class_Strat)
colnames(DataAnalyseEA)<-c("Society","MHP","StratificationEA_Class_Strat")
DataAnalyseEA<-as.data.frame(DataAnalyseEA)
Societe_Donnees_Manquantes<-unique(c(which(is.na(DataAnalyseEA$MHP)==T),which(is.na(DataAnalyseEA$StratificationEA_Class_Strat)==T)))
DataAnalyseEA<-DataAnalyseEA[-Societe_Donnees_Manquantes,] #Supprimer les socits avec donnes manquantes du jeu de donnes
DataAnalyseEA$StratificationEA_Class_Strat<-as.numeric(as.character(DataAnalyseEA$StratificationEA_Class_Strat))# Prendre en compte les valeurs
#Rassemblement des classes
DataAnalyseEA$StratificationEA_Class_Strat[which(DataAnalyseEA$StratificationEA_Class_Strat==2)]<-1
DataAnalyseEA$StratificationEA_Class_Strat[which(DataAnalyseEA$StratificationEA_Class_Strat==3)]<-2
DataAnalyseEA$StratificationEA_Class_Strat[which(DataAnalyseEA$StratificationEA_Class_Strat==4)]<-2
DataAnalyseEA$StratificationEA_Class_Strat <- DataAnalyseEA$StratificationEA_Class_Strat[ , drop=TRUE]


#Test de corrlation entre les variables #
CorAnalysis<-merge(DataAnalyse,DataAnalyseEA,by.x="Society",by.y="Society")
cbind(CorAnalysis$Stratification,CorAnalysis$StratificationEA_Class_Strat)
cor.test(CorAnalysis$Stratification,CorAnalysis$StratificationEA_Class_Strat,    method = "kendall",   na.action=na.omit)


dim(DataAnalyse) #Nombre de Donnes eHRAF
dim(DataAnalyseEA) #Nombre de DOnnes EA
length(DataAnalyse$Society[-which( DataAnalyse$Society%in% DataAnalyseEA$Society)]) #Donnes eHRAF non prsente dans donnes EA

#================================================================================================================================#
#================================================================================================================================#
#================================================================================================================================#

#================================================================================================================================#
#=============================== ANALYSE DANS ARTICLE ===========================================================================#
#================================================================================================================================#

#================================================================================================================================#
#================================================================================================================================#
#================================================================================================================================#

#================================================================================================================================#
#=============================== Analyse, avec variable stratification eHRAF ====================================================#
#================================================================================================================================#
datasave<-data #Sauver les donnes compltes de data
dataSocietesave<-dataSociete #Sauver les donnes compltes de dataSociete

#=== Variable Stratification ===#
dataSociete$Nbe_de_Classes_sociales<-as.character(dataSociete$Nbe_de_Classes_sociales)
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="1")]       <-1
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="1 ou 2")] <-1.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="2")]       <-2
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="2 ou 3")]  <-2.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="3")]       <-3
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="3 ou 4")]  <-3.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="4")]       <-4
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="4 ou 5")]  <-4.5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="5")]       <-5
dataSociete$Nbe_de_Classes_sociales[which(dataSociete$Nbe_de_Classes_sociales=="")]        <-NA

dataSociete$Nbe_de_Classes_sociales<-as.numeric(dataSociete$Nbe_de_Classes_sociales)

#=== Modle GEE - Generalized Estimating Equations (Paradis & Claude 2002) ===#
# Extraction donnes utiles #
DataAnalyse<-cbind(as.character(dataSociete$Societe_ASJP),dataSociete$Prfrence_homosexuelle,dataSociete$Nbe_de_Classes_sociales)
colnames(DataAnalyse)<-c("Society","MHP","Stratification")
DataAnalyse<-as.data.frame(DataAnalyse)
# Suppression des socits avec donnes manquantes #
Societe_Donnees_Manquantes<-unique(c(which(is.na(DataAnalyse$MHP)==T),which(is.na(DataAnalyse$Stratification)==T)))
datasave<-data
for(i in 1:length(DataAnalyse$Society[Societe_Donnees_Manquantes] )) #Supprimer les socits avec donnes manquantes de l'arbre phylogntique
      {
        data<-drop.tip(data,which(data$tip==DataAnalyse$Society[Societe_Donnees_Manquantes][i]))
      }
DataAnalyse<-DataAnalyse[-Societe_Donnees_Manquantes,] #Supprimer les socits avec donnes manquantes du jeu de donnes
rownames(DataAnalyse)<-DataAnalyse$Society
DataAnalyse<-DataAnalyse[,-1]
all(rownames(DataAnalyse) %in% data$tip.label) # Tester si les donnes de la phylognie correspondent bien  celle de la base de donnes. 
all(data$tip.label %in% rownames(DataAnalyse)) # Tester si les donnes de la phylognie correspondent bien  celle de la base de donnes. 
#=== Fin transformation nom ===#

data2<-data
DataAnalyse$Stratification<-as.numeric(as.character(DataAnalyse$Stratification))# Prendre en compte les valeurs

# Transformation de ma variable en trois facteurs: Trs stratifi, moyennement & peu stratifi#
DataAnalyse$Stratification[which(DataAnalyse$Stratification<2)]<-0
DataAnalyse$Stratification[which(DataAnalyse$Stratification<3.5 & DataAnalyse$Stratification>=2)]<-1
DataAnalyse$Stratification[which(DataAnalyse$Stratification>=3.5)]<-2

table(DataAnalyse$MHP,DataAnalyse$Stratification)
DataAnalyse$Stratification<-as.factor(DataAnalyse$Stratification)

#Modle
model<-compar.gee(DataAnalyse$MHP~DataAnalyse$Stratification
                  , data = DataAnalyse, family = "binomial", data2, scale.fix = FALSE, scale.value = 1)
drop1(model)
model$nobs
model
















#================================================================================================================================# 
#================== Analyse, avec variable Class stratification (EA) ============================================================#
#================================================================================================================================#
data<-datasave #Rcuprer les donnes compltes de data
dataSociete<-dataSocietesave

#=== Variable Stratification EA Class_strat===#
dataSociete$Class_Strat<-as.character(dataSociete$Class_Strat)
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="NA")]                       <-NA
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="absence among freemen")]    <-0
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="wealth distinctions")]      <-1
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="elite")]                    <-2
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="dual")]                     <-3
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="complex")]                  <-4
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="missing data")]             <-NA
dataSociete$Class_Strat<-as.numeric(dataSociete$Class_Strat)

#=== Modle GEE - Generalized Estimating Equations (Paradis & Claude 2002) ===#
# Extraction donnes utiles #
DataAnalyse<-cbind(as.character(dataSociete$Societe_ASJP),dataSociete$Prfrence_homosexuelle,dataSociete$Class_Strat)
colnames(DataAnalyse)<-c("Society","MHP","StratificationEA_Class_Strat")
DataAnalyse<-as.data.frame(DataAnalyse)

# Suppression des socits avec donnes manquantes #
Societe_Donnees_Manquantes<-unique(c(which(is.na(DataAnalyse$MHP)==T),which(is.na(DataAnalyse$StratificationEA_Class_Strat)==T)))

datasave<-data
for(i in 1:length(DataAnalyse$Society[Societe_Donnees_Manquantes] )) #Supprimer les socits avec donnes manquantes de l'arbre phylogntique
    {
      data<-drop.tip(data,which(data$tip==DataAnalyse$Society[Societe_Donnees_Manquantes][i]))
    }

DataAnalyse<-DataAnalyse[-Societe_Donnees_Manquantes,] #Supprimer les socits avec donnes manquantes du jeu de donnes
rownames(DataAnalyse)<-DataAnalyse$Society
DataAnalyse<-DataAnalyse[,-1]

all(rownames(DataAnalyse) %in% data$tip.label) # Tester si les donnes de la phylognie correspondent bien  celle de la base de donnes. 
all(data$tip.label %in% rownames(DataAnalyse)) # Tester si les donnes de la phylognie correspondent bien  celle de la base de donnes. 
#=== Fin transformation nom ===#

data2<-data
DataAnalyse$StratificationEA_Class_Strat<-as.numeric(as.character(DataAnalyse$StratificationEA_Class_Strat))# Prendre en compte les valeurs

# Transformation de ma variable : Trs stratifi vs Peu stratifi#
DataAnalyse$StratificationEA_Class_Strat[which(DataAnalyse$StratificationEA_Class_Strat==2)]<-1
DataAnalyse$StratificationEA_Class_Strat[which(DataAnalyse$StratificationEA_Class_Strat==3)]<-2
DataAnalyse$StratificationEA_Class_Strat[which(DataAnalyse$StratificationEA_Class_Strat==4)]<-2
DataAnalyse$StratificationEA_Class_Strat <- DataAnalyse$StratificationEA_Class_Strat[ , drop=TRUE]


# Transformation de ma variable en trois facteurs: Trs stratifi, moyennement & peu stratifi#
length(DataAnalyse$StratificationEA_Class_Strat)
table(DataAnalyse$MHP,DataAnalyse$StratificationEA_Class_Strat)
DataAnalyse$StratificationEA_Class_Strat<-as.numeric(DataAnalyse$StratificationEA_Class_Strat)
is.factor(DataAnalyse$StratificationEA_Class_Strat)
DataAnalyse$StratificationEA_Class_Strat<-as.factor(DataAnalyse$StratificationEA_Class_Strat)

#===========================================================#
#===============# Suppression de ICELANDIC #================#
#===========================================================#
data<-drop.tip(data,which(data$tip=="ICELANDIC"))
DataAnalyse<-DataAnalyse[-which(rownames(DataAnalyse)=="ICELANDIC"),]
#============================================================#
#===============# Suppression de ICELANDIC  #================#
#============================================================#

#Modle 
DataAnalyse$StratificationEA_Class_Strat<-as.factor(DataAnalyse$StratificationEA_Class_Strat)
modelA<-compar.gee(DataAnalyse$MHP~DataAnalyse$StratificationEA_Class_Strat
                  ,data=DataAnalyse, family = "binomial", data, scale.fix = FALSE, scale.value = 1)
drop1(modelA)
modelA$nobs
modelA


















#=========================================================================================================#
#=================  Analyse en prenant en compte la distance entre les socits  =========================#
#=========================================================================================================#

#======= Cration de l'arbre phylogntique  partir des distances ====#
Position<- cbind(as.character(EAfact$v107[societe_strat_EA]), #Society Name
                 as.numeric(as.character(EAfact$v104[societe_strat_EA])), #Latitude
                 as.numeric(as.character(EAfact$v106[societe_strat_EA]))) #Longitude
Position<-as.data.frame(Position)
colnames(Position)<-c("Society","Latitude","Longitude")


Society_EA<-read.table("Strat_EA.txt",header=T,sep="\t")

Position2<-merge(Society_EA,Position, by.x="Societe_EA", by.y="Society") #Rcupration de la bonne variable de nom
Position<-Position2[,-c(1,3,4,5,6)]
colnames(Position)<-c("Society","Latitude","Longitude")

Distance<-matrix(data=NA, nrow= nrow(Position) , ncol= nrow(Position))

colnames(Distance)<- Position[,1]
rownames(Distance)<- Position[,1]


#=== Great circle Distance ===#
dg2rad<-function(dg) #Passer les angles de degrs  Radian
{
  rad<-dg/180*pi 
  return(rad)
}

DistFunc<- function(long1, lat1, long2, lat2) { #Calculer la distance du grand cercle 
  R <- 6371 # Earth mean radius [km]
  # d <- acos(sin(lat1)*sin(lat2) + cos(lat1)*cos(lat2) * cos(long2-long1)) * R
  d <- 2*R* asin( 
    sqrt( 
      sin((lat2-lat1)/2)^2+cos(lat2)*cos(lat1)*sin((long2-long1)/2)^2               
    )  
  )
  return(d) # Distance in km
}

#=======================================================#
#==== Remplir la matrice de distance inter socits ====#
#=======================================================#

for(i in 1:nrow(Distance))
{
  for(j in 1:ncol(Distance))
  {
    society1<-colnames(Distance)[i]
    society2<-rownames(Distance)[j]
    
    latSoc1<-as.numeric(as.character(Position$Latitude[which(Position$Society==society1)]))
    longSoc1<-as.numeric(as.character(Position$Longitude[which(Position$Society==society1)]))
    
    latSoc2<-as.numeric(as.character(Position$Latitude[which(Position$Society==society2)]))
    longSoc2<-as.numeric(as.character(Position$Longitude[which(Position$Society==society2)]))
    
    Distance[i,j]<-DistFunc(dg2rad(latSoc1),dg2rad(longSoc1),dg2rad(latSoc2),dg2rad(longSoc2))
  }    
}

arb<-nj(Distance)
#==== Fin cration de l'arbre  partir des distances ====#


#=======================================================#
#================== Analyse ============================#
#=======================================================#

#================================================================================================================================#
#=============================== Analyse, avec variable class stratification EA ====================================================#
#================================================================================================================================#

data<-datasave #Rcuprer les donnes compltes de data
dataSociete<-dataSocietesave

#=== Variable Stratification EA Class_strat===#
dataSociete$Class_Strat<-as.character(dataSociete$Class_Strat)
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="NA")]                       <-NA
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="absence among freemen")]    <-0
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="wealth distinctions")]      <-1
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="elite")]                    <-2
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="dual")]                     <-3
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="complex")]                  <-4
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="missing data")]             <-NA
dataSociete$Class_Strat<-as.numeric(dataSociete$Class_Strat)

#=== Modle GEE - Generalized Estimating Equations (Paradis & Claude 2002) ===#
# Extraction donnes utiles #
DataAnalyse<-cbind(as.character(dataSociete$Societe_ASJP),dataSociete$Prfrence_homosexuelle,dataSociete$Class_Strat)
colnames(DataAnalyse)<-c("Society","MHP","StratificationEA_Class_Strat")
DataAnalyse<-as.data.frame(DataAnalyse)

# Suppression des socits avec donnes manquantes #
Societe_Donnees_Manquantes<-unique(c(which(is.na(DataAnalyse$MHP)==T),which(is.na(DataAnalyse$StratificationEA_Class_Strat)==T)))

datasave<-data
for(i in 1:length(DataAnalyse$Society[Societe_Donnees_Manquantes])) #Supprimer les socits avec donnes manquantes de l'arbre phylogntique
    {
      if(length(which(arb$tip==DataAnalyse$Society[Societe_Donnees_Manquantes][i]))==0)
        {print("Manquant")}
      else
        {
          arb<-drop.tip(arb,which(arb$tip==DataAnalyse$Society[Societe_Donnees_Manquantes][i]))
        }
    }

DataAnalyse<-DataAnalyse[-Societe_Donnees_Manquantes,] #Supprimer les socits avec donnes manquantes du jeu de donnes
rownames(DataAnalyse)<-DataAnalyse$Society
DataAnalyse<-DataAnalyse[,-1]

# Suppression problmes #
arb<-drop.tip(arb,which(arb$tip=="YUMA"))

all(rownames(DataAnalyse) %in% arb$tip.label) # Tester si les donnes de la phylognie correspondent bien  celle de la base de donnes. 
all(arb$tip.label %in% rownames(DataAnalyse)) # Tester si les donnes de la phylognie correspondent bien  celle de la base de donnes. 

DataAnalyse$StratificationEA_Class_Strat<-as.numeric(as.character(DataAnalyse$StratificationEA_Class_Strat))# Prendre en compte les valeurs

table(DataAnalyse$MHP,DataAnalyse$StratificationEA_Class_Strat)

arbsave<-arb
arb$edge.length<-arb$edge.length+1
#Test rassembler les donnes
DataAnalyse$StratificationEA_Class_Strat2<-DataAnalyse$StratificationEA_Class_Strat
DataAnalyse$StratificationEA_Class_Strat2[which(DataAnalyse$StratificationEA_Class_Strat2==2)]<-1
DataAnalyse$StratificationEA_Class_Strat2[which(DataAnalyse$StratificationEA_Class_Strat2==3)]<-2
DataAnalyse$StratificationEA_Class_Strat2[which(DataAnalyse$StratificationEA_Class_Strat2==4)]<-2
DataAnalyse$StratificationEA_Class_Strat2 <- DataAnalyse$StratificationEA_Class_Strat2[ , drop=TRUE]

DataAnalyse$StratificationEA_Class_Strat2<-as.factor(DataAnalyse$StratificationEA_Class_Strat2)

#===========================================================#
#===============# Suppression de ICELANDIC #================#
#===========================================================#
arb<-drop.tip(arb,which(arb$tip=="ICELANDIC"))
DataAnalyse<-DataAnalyse[-which(rownames(DataAnalyse)=="ICELANDIC"),]
arbsave<-arb
#===========================================================#
#===============# Suppression de ICELANDIC #================#
#===========================================================#

#=== Model with geographic distance ===#
arb<-arbsave
arb$edge.length[which(arb$edge.length==0)]<-1
arb<-compute.brlen(arb,power=1)
plot(arb)

modelC<-compar.gee(DataAnalyse$MHP~DataAnalyse$StratificationEA_Class_Strat2
                  ,data=DataAnalyse,family = "binomial", arb, scale.fix = FALSE, scale.value = 1)
drop1(modelC)
modelC




      























#================================================================================================================================#
#=============================== Analyse, avec les groupes rgionaux comme covariable  ==========================================#
#================================================================================================================================#

data<-datasave #Rcuprer les donnes compltes de data
dataSociete<-dataSocietesave

#=== Variable Stratification EA Class_strat===#
dataSociete$Class_Strat<-as.character(dataSociete$Class_Strat)
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="NA")]                       <-NA
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="absence among freemen")]    <-0
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="wealth distinctions")]      <-1
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="elite")]                    <-2
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="dual")]                     <-3
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="complex")]                  <-4
dataSociete$Class_Strat[which(dataSociete$Class_Strat=="missing data")]             <-NA
dataSociete$Class_Strat<-as.numeric(dataSociete$Class_Strat)

#=== Modle GEE - Generalized Estimating Equations (Paradis & Claude 2002) ===#
# Extraction donnes utiles #
DataAnalyse<-cbind(as.character(dataSociete$Societe_ASJP),dataSociete$Prfrence_homosexuelle,dataSociete$Class_Strat,as.character(dataSociete$Continent))
colnames(DataAnalyse)<-c("Society","MHP","StratificationEA_Class_Strat","Continent")
DataAnalyse<-as.data.frame(DataAnalyse)

# Suppression des socits avec donnes manquantes #
Societe_Donnees_Manquantes<-unique(c(which(is.na(DataAnalyse$MHP)==T),which(is.na(DataAnalyse$StratificationEA_Class_Strat)==T)))

DataAnalyse$Society[Societe_Donnees_Manquantes]
DataAnalyse[Societe_Donnees_Manquantes,]

DataAnalyse<-DataAnalyse[-Societe_Donnees_Manquantes,] #Supprimer les socits avec donnes manquantes du jeu de donnes
DataAnalyse<-DataAnalyse[-which(DataAnalyse$Society=="BISLAMA"),]   
rownames(DataAnalyse)<-DataAnalyse$Society
DataAnalyse<-DataAnalyse[,-1]

# Transformation de ma variable en trois facteurs: Trs stratifi, moyennement & peu stratifi#
DataAnalyse$StratificationEA_Class_Strat[which(DataAnalyse$StratificationEA_Class_Strat==2)]<-1
DataAnalyse$StratificationEA_Class_Strat[which(DataAnalyse$StratificationEA_Class_Strat==3)]<-2
DataAnalyse$StratificationEA_Class_Strat[which(DataAnalyse$StratificationEA_Class_Strat==4)]<-2
DataAnalyse$StratificationEA_Class_Strat <- DataAnalyse$StratificationEA_Class_Strat[ , drop=TRUE]
DataAnalyse$StratificationEA_Class_Strat<-as.factor(as.character(DataAnalyse$StratificationEA_Class_Strat))# Prendre en compte les valeurs

table(DataAnalyse$MHP,DataAnalyse$StratificationEA_Class_Strat)

model<-glm(DataAnalyse$MHP~DataAnalyse$StratificationEA_Class_Strat+DataAnalyse$Continent , family=binomial)
summary(model)
Anova(model,type="II")
summary(model)


# Calcul de la dviance explique #
pseudoR2<-(summary(model)$null.deviance-summary(model)$deviance)/summary(model)$null.deviance


# Calcul du Nagelkerke R #
MHPA<-DataAnalyse$MHP
Strat<-DataAnalyse$StratificationEA_Class_Strat
Conti<-DataAnalyse$Continent

modelGLM<-lrm(MHPA~Strat+Conti,na.action=na.delete,
    method="lrm.fit", model=F, x=T, y=FALSE, linear.predictors=T, se.fit=T)
modelGLM$stats

# Analyse sans l'amrique du Nord #
DataAnalyseSansNA<-DataAnalyse[-which(DataAnalyse$Continent=="North_America"),]
model<-glm(DataAnalyseSansNA$MHP~DataAnalyseSansNA$StratificationEA_Class_Strat+DataAnalyseSansNA$Continent , family=binomial)
summary(model)
Anova(model,type="II")
pseudoR2<-(summary(model)$null.deviance-summary(model)$deviance)/summary(model)$null.deviance
